// relayDlg.h : header file
// Written by Philip Allen 
// 
// Version 1.0	 2 June 2004    Initial Version
// Version 2.0	28 August 2007  Addition of Comm select dialogue box
// Version 2.1	30 August 2007  Correction for use of Com ports over 6
// Version 3.1   6 Setember 2007 Rewrite to use serial port
//
//
//{{AFX_INCLUDES()
//}}AFX_INCLUDES

#if !defined(AFX_RELAYDLG_H__8EF14366_0039_4832_B9F4_8F8D69715556__INCLUDED_)
#define AFX_RELAYDLG_H__8EF14366_0039_4832_B9F4_8F8D69715556__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Resource.h"

/////////////////////////////////////////////////////////////////////////////
// CRelayDlg dialog

class CRelayDlg : public CDialog
{
// Construction
public:
	CRelayDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRelayDlg)
	enum { IDD = IDD_RELAY_DIALOG };
	CButton	m_cmdOpenRelay;
	CButton	m_cmdClearRelays;
	CEdit	m_edtSetRelay;
	CButton	m_cmdApply;
	CStatic	m_stcPortSelect;
	CStatic	m_stcNumRelays;
	CButton	m_cmdStartStop;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRelayDlg)
	public:
	virtual int DoModal();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

	public:

	void SetUpControls(void);
	void ClearSettings(void);
	void Initialise (void);
	void CRelayDlg::SetControlStatus( bool state);
	//void SendCommand (char bank, unsigned short relay);
	void CheckComSettings(int Comport);
	void CheckRelaySettings(int nRelay);
	void OperateRelay (int RelayNum);
	bool InitialiseRelays(void) ;

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CRelayDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSetupBtn();
	afx_msg void OnQuitBtn();
	afx_msg void OnApplyBtn();
	afx_msg void OnControlRadio();
	afx_msg void OnNumberRadio();
	afx_msg void OnFileExit();
	afx_msg void OnPortCom1();
	afx_msg void OnPortCom2();
	afx_msg void OnPortCom3();
	afx_msg void OnPortCom4();
	afx_msg void OnPortCom5();
	afx_msg void OnRelays16();
	afx_msg void OnRelays24();
	afx_msg void OnRelays8();
	afx_msg void OnPortCom6();
	afx_msg void OnStartStop();
	afx_msg void OnChangeEditSetRelay();
	afx_msg void OnPortComSel();
	afx_msg void OnCheck1();
	afx_msg void OnCheck10();
	afx_msg void OnCheck11();
	afx_msg void OnCheck12();
	afx_msg void OnCheck13();
	afx_msg void OnCheck14();
	afx_msg void OnCheck15();
	afx_msg void OnCheck16();
	afx_msg void OnCheck17();
	afx_msg void OnCheck18();
	afx_msg void OnCheck19();
	afx_msg void OnCheck2();
	afx_msg void OnCheck20();
	afx_msg void OnCheck21();
	afx_msg void OnCheck22();
	afx_msg void OnCheck23();
	afx_msg void OnCheck24();
	afx_msg void OnCheck3();
	afx_msg void OnCheck4();
	afx_msg void OnCheck5();
	afx_msg void OnCheck6();
	afx_msg void OnCheck7();
	afx_msg void OnCheck8();
	afx_msg void OnCheck9();
	afx_msg void OnClearRelays();
	afx_msg void OnOpenRelay();
	afx_msg void OnHelpAbout();
	afx_msg void OnHelpDevicemanager();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	CButton mRelayChk[25];  // Element 0 not used. Done to keep numbering simple
	CButton mRelayBank1;	// Group box 1 control
	CButton mRelayBank2;	// Group box 2 control
	CButton mRelayBank3;	// Group box 3 control

	CButton mNumberRd;		// Control for Number radio button 
	CButton mControlRd;		// Control for Check radio button

	CMenu * m_mainMenu;		// Main Menu handle
	CMenu * m_pmnuPort;		// Com port select menu handle
	CMenu * m_pmnuRelayNum;	// Number of Relays select menu handle

	int mNumberRelaysAvailable; // Holds number of relsys selected
	CString mCommPortUsed;		// Identity of com port selected
	unsigned short m_uApplyValue; // Holds bit setting for individual relay control
	int mPort;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RELAYDLG_H__8EF14366_0039_4832_B9F4_8F8D69715556__INCLUDED_)
